//+------------------------------------------------------------------+
//|                                            ReportHTMLtoCSV-2.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.ru/"

#define capacity  10000

#property show_inputs
//#property stacksize 1000000
extern string filename = "StrategyTester.htm";

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void PrintStringArray(string array[],string nameOfArray)
   {
//----
   Print(" ",nameOfArray);
   for (int i = 0; i < ArraySize(array); i++)
      {
      Print(i, ":", array[i]);
      }
   Print("  ");
//----
   return;      
   }

//+------------------------------------------------------------------+
//|       array[]                  |
//|     false                                    |
//+------------------------------------------------------------------+
bool ReadFileToArray(string & array[], string FileName, string WorkFolderName)
  {
   bool res = false;
   int FileHandle;
   string tempArray[64000], currString;
   int stringCounter;
   int devider = '\x90';
   string FullFileName;
   if (StringLen(WorkFolderName) > 0) FullFileName = StringConcatenate(WorkFolderName, "\\", FileName);
   else FullFileName = FileName;
//----
   Print("   ", FileName);
   FileHandle=FileOpen(FullFileName, FILE_READ, devider);
   if (FileHandle != -1)
      {
      while(!FileIsEnding(FileHandle)) 
         {
         tempArray[stringCounter] = FileReadString(FileHandle);
         stringCounter++;
         }
      stringCounter--;
      if (stringCounter > 0) 
         {
         ArrayResize(array,stringCounter);
         for (int i = 0; i < stringCounter; i++) array[i] = tempArray[i];
         res = true;
         }
      FileClose(FileHandle);   
      }
   else
      {
      Print("    ", FileName);
      }      
//----
   return(res);
  }


//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
void setPositions(int & st[][], int & en[][], int counter,int stLine, int stPos, int enLine, int enPos)
   {
//----
   st[counter][0] = stLine;
   st[counter][1] = stPos;

   en[counter][0] = enLine;
   en[counter][1] = enPos;

//----
   return;
   }

//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void FillTagStructure(string  & structure[],//   
                      int     & start[][],  //   (, )
                      int     & end[][],    //   (, )
                      string  array[])      //  html-
   {
//----
   int array_Size = ArraySize(array);
   
   ArrayResize(structure, capacity);
   ArrayResize(start, capacity);
   ArrayResize(end, capacity);
   
   int i=0, line, posOpen, pos_, posClose, tagCounter, currPos = 0;
   string currString;
   string tag;
   int curCapacity = capacity;
   while (i < array_Size)
      {
      if (tagCounter >= curCapacity)                     //      
         {                                               //   
         ArrayResize(structure, curCapacity + capacity); //    
         ArrayResize(start, curCapacity + capacity);     //       
         ArrayResize(end, curCapacity + capacity);       //              
         curCapacity += capacity;                        //    
         }
      
      currString = array[i];                             //   
      //Print(currString);
      posOpen = StringFind(currString, "<", currPos);    //    "<"   currPos
      if (posOpen == -1)                                 //  
         {
         line = i;                                       //    
         currPos = 0;                                    //        
         i++;
         continue;                                       //    
         }
         
      //     ,  "<"       
      pos_ = StringFind(currString, " ", posOpen);       //     
      posClose = StringFind(currString, ">", posOpen);   //      
      if ((pos_ == -1) && (posClose != -1))              //   ,   
         {
         tag = StringSubstr(currString, posOpen, posClose - posOpen) + ">";
         //  
         structure[tagCounter] = tag;                    //      
         setPositions(start, end, tagCounter, i, posOpen, i, posClose+1);
         tagCounter++;                                   //     
         currPos = posClose;                             //       
         continue;                                       //     posClose,    
         }
         

      //      ,       
      if ((pos_ != -1) && (posClose != -1))
         {
         if (pos_ > posClose)                            //     
            {
            tag = StringSubstr(currString, posOpen, posClose - posOpen) + ">";
            //  
            structure[tagCounter] = tag;                 //      
            setPositions(start, end, tagCounter, i, posOpen, i, posClose+1);
            tagCounter++;                                //     
            currPos = posClose;                          //       
            continue;                                    //     posClose,    
            }

         //  ,     ,   
         if (pos_ < posClose)
            {
            tag = StringSubstr(currString, posOpen, pos_ - posOpen) + ">";
            //  
            structure[tagCounter] = tag;                 //      
            setPositions(start, end, tagCounter, i, posOpen, i, posClose+1);
            tagCounter++;                                //     
            currPos = posClose;                          //       
            continue;                                    //     posClose,    
            }
         }

      //      ,        
      if ((pos_ == -1) && (posClose == -1))
         {
         tag = StringSubstr(currString, posOpen) + ">";  //       
         structure[tagCounter] = tag;                    //      
         while (posClose == -1)                          //      
            {                                            //    
            i++;                                         //    
            currString = array[i];                       //    
            posClose = StringFind(currString, ">");      //       
            }
         setPositions(start, end, tagCounter, i, posOpen, i, posClose+1);
         tagCounter++;                                   //     
         currPos = posClose;                             //   ,    
         }                                               //     
      }
   ArrayResize(structure, tagCounter);                   //         
//----                                                   //  
   return;   
   }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetContent(string array[], int start[1][2],int  end[1][2])
   {
   string res = "";
//----
   int startLine = start[0][0];
   int startPos = start[0][1];

   int endtLine = end[0][0];
   int endPos = end[0][1];
   string currString;
   
   for (int i = startLine; i<=endtLine; i++)
      {
      currString = array[i];
      if (i == startLine && endtLine > startLine)
         {
         res = res + StringSubstr(currString, startPos);
         }
      if (i > startLine && i < endtLine)
         {
         res = res + currString;
         }
         
      if (endtLine > startLine && i == endtLine)
         {
         if (endPos > 0) res = res + StringSubstr(currString, 0, endPos);
         }
         
      if (endtLine == startLine && i == endtLine)
         {
         if (endPos - startPos > 0) res = res + StringSubstr(currString, startPos, endPos - startPos);
         }
      }
//----
   return(res);   
   }  
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   int i;
   string array[];

   ReadFileToArray(array, filename,"");
        
   string tags[];    //    
   int startPos[][2];//   
   int endPos[][2];  //   
   
   FillTagStructure(tags, startPos, endPos, array);
   int tagsNumber = ArraySize(tags);
   //PrintStringArray(tags, "tags    :"+ tagsNumber);
   string text = "";
   string currTag;
   int start[1][2];
   int end[1][2];

   //return;
   for (i = 0; i < tagsNumber; i++)
      {
      currTag = tags[i];
      //Print(tags[i],"\t\t  start pos=(",startPos[i][0],",",startPos[i][1],") \t end pos = (",endPos[i][0],",",endPos[i][1],")");

      if (currTag == "<table>")
         {
         Print(" ;");
         }

      if (currTag == "<tr>")
         {
         text = "";
         start[0][0] = -1;
         start[0][1] = -1;
         
         }

      if (currTag == "<td>")
         {//        
         start[0][0] = endPos[i][0];
         start[0][1] = endPos[i][1];
         }

      if (currTag == "</td>")
         {//        
         end[0][0] = startPos[i][0];
         end[0][1] = startPos[i][1];
         }

      if (currTag == "</td>")
         {//        
         end[0][0] = startPos[i][0];
         end[0][1] = startPos[i][1];
         text = text + GetContent(array, start, end) + ";";
         }

      if (currTag == "</tr>")
         {
         Print(text);
         }

      if (currTag == "</table>")
         {
         Print(" ;");
         }

      }
//----
   return(0);
  }
//+------------------------------------------------------------------+